﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CG1.Ex01.Mathematics
{
    // Info: We will use 'structs' instead of 'classes' here. Maybe this will explain why: http://goo.gl/8w6bo
    // Vector is defined in homogeneous coordinates to resolve affine transformatin problem
	public struct Vector4
	{
		#region Properties

		public static readonly Vector4 Zero = new Vector4(0, 0, 0, 0);
        //ToDo: Declare also 4 unit vectors UnitX, UnitY... 

        //ToDo: Declare 4 variables of Vector4 (X, Y...) You should use Double type.

		public Double Length
		{
            get
            {
                //ToDo: Create an indexer / a property Length.
                //      This property will return vector's length. 
                //      Use accessor method 'get'
                //      Return value is Double.
                return 0;
            }
		}

		#endregion

		#region Init

		public Vector4(Double x, Double y, Double z, Double w = 0)
		{
            //ToDo: You should initialize vector's 4 variables here.
		}

		#endregion

		#region Arithmetic Operations

		public static Vector4 operator +(Vector4 a, Vector4 b)
		{
            //ToDo: This function will return addition of two vectors.
            //      We can return new vector (declared with content of function) automatically.
            return Vector4.Zero;
		}

		public static Vector4 operator -(Vector4 a, Vector4 b)
		{
            //ToDo: This function will return subtraction of two vectors.
            return Vector4.Zero;
		}

		public static Vector4 operator *(Vector4 a, Double b)
		{
            //ToDo: This function will return vector multiplied by number.
            return Vector4.Zero;
		}

		public static Vector4 operator *(Double a, Vector4 b)
		{
            //ToDo: This function will return vector multiplied by number.
            return Vector4.Zero;
		}

		/// <summary>
		/// Dot Product
		/// </summary>
		/// <param name="a"></param>
		/// <param name="b"></param>
		/// <returns></returns>
		public static Double operator *(Vector4 a, Vector4 b)
		{
            //ToDo: This function will return dot product of two vectors.
            return 0;
		}

		/// <summary>
		/// 3D Cross Product
		/// </summary>
		/// <param name="a"></param>
		/// <param name="b"></param>
		/// <returns></returns>
		public static Vector4 operator %(Vector4 a, Vector4 b)
		{
            //ToDo: This function will return 3D cross product of two vectors.
            return Vector4.Zero;
		}

        /// <summary>
        /// Projection of vector along another vector
        /// </summary>
        /// <param name="a"></param>
        /// <param name="b"></param>
        /// <returns></returns>
        public static Vector4 operator /(Vector4 a, Vector4 b)
        {
            //ToDo: This function will return projection of vector 'a' along vector 'b'
            return Vector4.Zero;
        }

        /// <summary>
        /// Modulation Product
        /// </summary>
        /// <param name="a"></param>
        /// <param name="b"></param>
        /// <returns></returns>
        public static Vector4 operator ^(Vector4 a, Vector4 b)
        {
            //ToDo: This function will return a modulation product of two vectors
            return Vector4.Zero;
        }

		#endregion

	}
}
