﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace CG1.Ex01.Mathematics
{
	public struct Matrix44
	{
		#region Properties

		public const Int32 Dim = 4;

        public static readonly Matrix44 Zero = new Matrix44(0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);

        //ToDo: Declare all variables of Matrix44 (M00, M01, M02, M03...). 
        //      You should use Double type.

		public static Matrix44 Identity
		{
            get
            {
            //ToDo: Create an indexer / a property Identity.
            //      This property will return Identity matrix. 
            //      Use accessor method 'get'
            //      Return value is Matrix.
            //      Help from uncle Google? F.e. http://goo.gl/kuvAG
                return Matrix44.Zero;
            }
		}

        public Matrix44 Transposed
        {
            //ToDo: Create an property for transposed matrix.
            get
            {
                return Matrix44.Zero;
            }
        }

        public Double Determinant
        {
            //ToDo: Create an property for determinant matrix.
            get
            {
                return 0;
            }
        }

        public Matrix44 Inversed
        {
            //ToDo: Create an property for inversed matrix.
            get
            {
                return Matrix44.Zero;
            }
        }

		#endregion

		#region Init

		public Matrix44(
			Double m00, Double m01, Double m02, Double m03,
			Double m10, Double m11, Double m12, Double m13,
			Double m20, Double m21, Double m22, Double m23,
			Double m30, Double m31, Double m32, Double m33)
		{
            //ToDo: You should initialize matrix's 16 variables here.
		}

		#endregion

		#region Arithmetic Operations

		public static Matrix44 operator -(Matrix44 a)
		{
            //ToDo: This function will return matrix with opposite values.
            return Matrix44.Zero;
		}

		public static Matrix44 operator +(Matrix44 a, Matrix44 b)
		{
            //ToDo: This function will return addition of two matrices.
            return Matrix44.Zero;
		}

		public static Matrix44 operator -(Matrix44 a, Matrix44 b)
		{
            //ToDo: This function will return subtraction of two matrices.
            return Matrix44.Zero;
		}

		public static Matrix44 operator *(Matrix44 a, Matrix44 b)
		{
            //ToDo: This function will return multiplication of two matrices.
            return Matrix44.Zero;
		}

		public static Vector4 operator *(Vector4 a, Matrix44 b)
		{
            //ToDo: This function will return multiplication of vector and matrix.
            return Vector4.Zero;
		}

		public static Vector4 operator *(Matrix44 a, Vector4 b)
		{
            //ToDo: This function will return multiplication of matrix and vector.
            return Vector4.Zero;
		}

		#endregion

        #region Transformations

        public static Matrix44 Scale(Vector4 scaleVector)
        {
            //ToDo: This function will return scale matrix.
            return Matrix44.Zero;
        }

        public static Matrix44 Translate(Vector4 translateVector)
        {
            //ToDo: This function will return translate matrix.
            return Matrix44.Zero;
        }

        public static Matrix44 RotateX(double angleDeg)
        {
            //ToDo: This function will return rotation matrix around X axis.
            return Matrix44.Zero;
        }

        public static Matrix44 RotateY(double angleDeg)
        {
            //ToDo: This function will return rotation matrix around Y axis.
            return Matrix44.Zero;
        }

        public static Matrix44 RotateZ(double angleDeg)
        {
            //ToDo: This function will return rotation matrix around Z axis.
            return Matrix44.Zero;
        }

        #endregion
	}
}
